#!/usr/bin/perl
#	DISCUS 2.50/3.00 INTERACTIVE SETUP
#  CONGRATULATIONS!  THIS STEP WORKED PROPERLY!
#
#  Now, select "File | Save As..." from your browser's window.
#  This output should be saved as "ftpdiag.cgi" in any temporary
#  folder on your hard disk.  When you have saved the file, use your
#  browser's back button to return to the instructions.
#
#  This script is Copyright (c) 1998 by Kevin W. Paulisse and William
#  F. Polik.  It is governed by the General Use license of the Discus
#  discussion board program.  http://www.chem.hope.edu/discus
#
#
#
#
#

$| = 1;
print "Content-type: text/html\n\n";

eval '$home = (getpwuid($<))[7];';
if (!-e "C:/") {
	$pwd = `pwd`; chop $pwd;
}
if (!eval 'use Cwd;') {
    eval '$cwd = cwd();';
} else {
    $cwd = "";
}
$prog = $0;
$prog =~ m|ftpdiag\.(\w+)|; $prog = "ftpdiag.$1";
$cgi_extension = $1;
$b4 = $`; $b4 =~ s/\/$//; $b4 =~ s/\\$//;
$docroot = $ENV{'DOCUMENT_ROOT'};
$docroot =~ s/\/$//;
$docroot =~ s/\\$//;
$filename = $ENV{'SCRIPT_FILENAME'};
$filename =~ s/\/$prog//;
$filename =~ s/\\$prog//;
$path = $ENV{'PATH_TRANSLATED'};
$path =~ s/\/$//;
$path =~ s/\\$//;
&check($pwd);
&check($b4);
&check($home);
&check($docroot);
&check($filename);
&check($path);
&check($cwd);
if ($real eq "") {
	$real = &determine_cwd;
}


if ($real eq "") {
   print "<HTML><HEAD><TITLE>Sorry...</TITLE></HEAD>\n";
   print "<BODY><PRE><B>Setup Complication</B>\n\n";
   print "The setup script could not determine the current working directory\n";
   print "of the server.  This is very rare (only 1-2% of servers).  The environment\n";
   print "variables and other potentially helpful values are being printed here for\n";
   print "your reference:\n\n";
   print "<B>PWD</B>         $pwd\n";
   print "<B>Server home</B> $home\n";
   print "<B>Doc. Root</B>   $docroot\n";
   print "<B>File name</B>   $filename\n";
   print "<B>Path</B>        $path\n";
   print "<B>CWD</B>         $cwd\n\n";
   print "Here are the environment variables:\n\n";
   foreach $key (sort keys(%ENV)) {
       print "<B>$key</B> = [$ENV{$key}]\n";
   }
   print "\n\n";
   print "Due to this failure, you should probably use the above information\n";
   print "to use the <A HREF=\"http://www.chem.hope.edu/discus/ftp/ftp-detailed.html\">Discus FTP detailed instructions</A>.\n";
   print "</PRE></BODY></HTML>\n";
   exit(0);
}

opendir(CURDIR, "..");
while ($q = readdir(CURDIR)) {
    push (@founddir, $q);
}
closedir(CURDIR);
open (PROG, $prog);
@prog = <PROG>;
close (PROG);
$perl = $prog[0];
$perl =~ s/^#!//;
$real =~ s%\\%/%g;
$real =~ s%//%/%g;
if ($real =~ m|(.*)/(.+)|) {
	$base = $1; $cgi = $2;
} else {
	$base = $real; $cgi = "cgi-bin";
}
$admin_dir = "$base/discus_admin_";
$p = $$; $p =~ s/\D//g;
$p .= substr(time, 0, -5);
$admin_dir .= $p;
$poss_html_dir = "public_html htdocs htdoc html www doc docs wwwdoc wwwdocs wwwroot httpd";
@poss = split(/\s/, $poss_html_dir);
@founddir = grep(!/\./, @founddir);
foreach $dir (@poss) {
	if (grep(/^$dir$/, @founddir)) {
		$html_dir = "$base/$dir/discus";
		last;
	}
}
if ($html_dir eq "") {
	$html_dir = "$base/discus";
}

$script_dir = "$real/discus";
$sn = "";
if ($ENV{'SCRIPT_URI'} ne "") {
	$sn = $ENV{'SCRIPT_URI'};
} elsif ($ENV{'SCRIPT_URL'} ne "") {
	$sn = $ENV{'SCRIPT_URL'};
} elsif ($ENV{'REQUEST_URI'}) {
	$sn = $ENV{'REQUEST_URI'};
} elsif ($ENV{'SCRIPT_NAME'} ne "") {
	$sn = $ENV{'SCRIPT_NAME'};
}

if ($sn ne "") {
	if ($sn =~ m|^http://([^/]+)|) {
		$sn = $';
	}
	if ($sn =~ m|/$prog|) {
		$sn = $`;
	}
	if ($sn ne "") {
		$script_url = "http://$ENV{'HTTP_HOST'}$sn/discus";
	}
} else {
	$script_url = "http://$ENV{'HTTP_HOST'}/$cgi/disdcus";
}

if ($script_url =~ m|^http://([^/]+)/~([^/]+)/|) {
	$uinfo = "~" . $2 . "/";
}
$html_url = "http://$ENV{'HTTP_HOST'}/$uinfo" . "discus";

# For NT users, convert / to \ to make it look more familiar

$admin_dir =~ s%/%\\%g if $admin_dir =~ m|^(\w+):|;
$html_dir =~ s%/%\\%g if $html_dir =~ m|^(\w+):|;
$script_dir =~ s%/%\\%g if $script_dir =~ m|^(\w+):|;
$bdcgi = "$base/$cgi";
$bdcgi =~ s%/%\\%g if $admin_dir =~ m|^(\w+):|;
$admin_dir =~ s%\\\\%\\%g;
$html_dir =~ s%\\\\%\\%g;
$script_dir =~ s%\\\\%\\%g;
$bdcgi =~ s%\\\\%\\%g;

if (-e "C:/" || $^O eq "MSWin32") {
	$NTFLAG = '<INPUT TYPE=HIDDEN NAME=OS VALUE=NT>';
}

if ($] < 5) {
	$perl4warn = "<FONT COLOR=#ff0000><B>Perl Version Warning</B>:  The Perl path that\n";
	$perl4warn .= "you selected, <B>$perl</B>, is running Perl version $].\n";
	$perl4warn .= "Version 3.0 and 3.0 pro of Discus require Perl 5.  In most cases,\n";
	$perl4warn .= "there will not be any difficulties, but it is <U>strongly</U>\n";
	$perl4warn .= "recommended that you consult your ISP's documents and determine\n";
	$perl4warn .= "if you can select a different Perl path for Perl version 5.</FONT>\n";
}

print <<_END_;
<HTML><HEAD><TITLE>Discus Setup - Interactive Form</TITLE></HEAD>
<BODY BGCOLOR=#ffffff TEXT=#000000 LINK=#0000ff VLINK=#800080 BACKGROUND=http://www.chem.hope.edu/discus/rc/constructing_your_site/backgrounds/bg_017.jpg>
<BASEFONT SIZE=2>
<FONT FACE="Verdana, Arial, Helvetica" SIZE=2>
<FONT SIZE=4><CENTER><B>Discus Setup - Interactive Form</B></CENTER></FONT>
<HR SIZE=0><P>
<FORM ACTION="http://www.chem.hope.edu/cgi-bin/cgiwrap/discus/home2/ftp-inst.cgi" METHOD=POST>
<TABLE WIDTH=100% BORDER=0 CELLPADDING=0 CELLSPACING=0>
<TR>
<TD VALIGN=TOP BGCOLOR=#ccccff WIDTH=200><FONT FACE="Verdana,Arial,Helvetica" SIZE=2><CENTER><B>Introduction</B></CENTER><P><FONT SIZE=1>
This is important information that will help you when performing the setup of your board.  Please read it carefully!</FONT></FONT></TD> <TD>&nbsp;&nbsp;</TD>
<TD VALIGN=TOP>
<FONT FACE="Verdana,Arial,Helvetica" SIZE=2>
If you are seeing this page, you were successful in accomplishing the first phase of Discus setup! What you are now looking at is the equivalent of the normal Discus FTP setup form, except that on this form, information gathered about your system has been used to fill in <B>guesses</B> for the appropriate form variables.  You should review the changes, and fill in fields where appropriate (such as your board title).
<P>
<B>IMPORTANT:</B>  The parameters filled in this form are our <U>best guess</U> about your server configuration.  You may wish to change the directories or URLs to customize your board -- you may also <I>need</I> to change these.  <B>Don't just accept our guesses without reviewing them!</B>  This bears repeating.<P><B><FONT COLOR=#ff0000>Don't just accept our guesses without reviewing them (and changing them if necessary)!</FONT></B>
</TD></TR>

<TR><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>

<TR>
<TD VALIGN=TOP BGCOLOR=#ffccff WIDTH=200><FONT FACE="Verdana,Arial,Helvetica" SIZE=2><CENTER><B>Path to Perl</B></CENTER><P><FONT SIZE=1>
The Perl interpreter on your system interprets the Discus scripts and
presents the results to you in your browser.</FONT></FONT></TD>
<TD>&nbsp;&nbsp;</TD>
<TD VALIGN=TOP>
<FONT FACE="Verdana,Arial,Helvetica" SIZE=2>
<INPUT TYPE=HIDDEN NAME=version_requested VALUE="3_00">
<INPUT TYPE=HIDDEN NAME=language VALUE=English>
$NTFLAG

Enter the path to Perl for your system.  Your test CGI script used <B>$perl</B> for the path to Perl, so this should also work on all of the rest of the Discus scripts.  This Perl interpreter is running Perl version <B>$]</B>.
<P>
$perl4warn
<P>
<UL>
Path to Perl:
<TABLE><TR><TD><Input TYPE=text SIZE=40 NAME=pathperl VALUE="$perl"></TD></TR></TABLE>
</UL></FONT>
</TD></TR>

<TR><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>

<TR>
<TD VALIGN=TOP BGCOLOR=#ffccff WIDTH=200><FONT FACE="Verdana,Arial,Helvetica" SIZE=2><CENTER><B>CGI Extension</B></CENTER><P><FONT SIZE=1>
Your server needs to know what extension to use for CGI scripts on your server. On Windows NT servers, this often associates a particular extension directly with the Perl interpreter.</FONT></FONT></TD>
<TD>&nbsp;&nbsp;</TD>
<TD VALIGN=TOP>
<FONT FACE="Verdana,Arial,Helvetica" SIZE=2>
The CGI extension is the extension that must be given to files for the server to treat them
as CGI scripts.  Usually this is &quot;.cgi&quot; or &quot;.pl&quot; and sometimes either
will work.  Consult your ISP's documentation if you don't know.  Also keep in mind that this is probably case-sensitive (&quot;.cgi&quot; and &quot;.CGI&quot; are <I>not</I> the same). You used <B>$cgi_extension</B> as the extension for the test script, so this should work for all of the Discus scripts.
<P>
<UL>
CGI Extension:
<TABLE><TR><TD><Input TYPE=text SIZE=5 NAME=cgi_extension VALUE="$cgi_extension"></TD></TR></TABLE>
</UL></FONT>
</TD></TR>
<TR><TD>&nbsp;</TD></TR>

<TR>
<TD VALIGN=TOP BGCOLOR=#ffcccc WIDTH=200><FONT FACE="Verdana,Arial,Helvetica" SIZE=2><CENTER><B>Administration Directory</B></CENTER><P><FONT SIZE=1>
The administration directory stores configuration files and password files for your Discus board.  This directory should be &quot;hidden&quot; from the web server as described in this section.</FONT></FONT></TD>
<TD>&nbsp;&nbsp;</TD>
<TD VALIGN=TOP>
<FONT FACE="Verdana,Arial,Helvetica" SIZE=2>

When specifying directories, it is necessary to use the full directory path that your
server "sees" -- your server has reported seeing your test CGI script in <B>$bdcgi</B>.
This may or may not correspond to what you see when you log in with your FTP program, as some web hosts limit your access to only your own area on the machine.  In any case,
it is what is "seen" by this setup program, and that is all that counts!
<P>

This directory should not be accessible at <I>http://your.server.com/something</I>.
If you cannot &quot;hide&quot; this directory from your server, at least give it a non-standard name (if you call it &quot;discus_admin&quot; anyone at all can find it easily).  Otherwise, anyone from the WWW will be able to view privileged information for your Discus implementation, such as the log of all posts, all of your board configuration settings, and your password files!  The directory must be a <I>directory</I> and not a URL -- it should <B>not</B> start with <TT><B>http://</B></TT>!
<P>
<FONT COLOR=#aa0000><B>Example:</B>  To specify the Discus administration directory, we
suggest choosing a directory with a nonstandard name so it cannot be easily guessed.
Perhaps <B>$admin_dir</B> would be a good choice.</FONT>
<P>
<UL>
Administration Files Directory:
<TABLE><TR><TD><Input TYPE=text SIZE=50 NAME=admin_dir VALUE="$admin_dir"></TD></TR></TABLE>
</UL></FONT>
</TD></TR>

<TR><TD>&nbsp;</TD></TR>

<TR>
<TD VALIGN=TOP BGCOLOR=#ffcccc WIDTH=200><FONT FACE="Verdana,Arial,Helvetica" SIZE=2><CENTER><B>HTML Directory</B></CENTER><P><FONT SIZE=1>
The HTML directory stores HTML files that are used by Discus, such as the documentation and message files.  This directory does not go under your cgi-bin.</FONT></FONT></TD>
<TD>&nbsp;&nbsp;</TD>
<TD VALIGN=TOP>
<FONT FACE="Verdana,Arial,Helvetica" SIZE=2>

The HTML files that come with Discus, such as the instructions, main menu, and administration program framesetting document are placed in the &quot;HTML Files Directory.&quot;  In addition, your message files (topics and messages), clipart, and icons are all stored in subdirectories of the HTML Files Directory.  This should not go under
your server's CGI directory (i.e., don't put it under your cgi-bin).  The directory must be a <I>directory</I> and not a URL -- it should <B>not</B> start with <TT><B>http://</B></TT>!
<P>
<FONT COLOR=#aa0000><B>Example:</B>  <TT><B>$html_dir</B></TT></FONT>.  
<P>
<UL>
HTML Files Directory:
<TABLE><TR><TD><Input TYPE=text SIZE=50 NAME=html_dir VALUE="$html_dir"></TD></TR></TABLE>
</UL>
<P>
You also need to give the URL that corresponds to the HTML Files Directory that you specified above.  This <B>must</B> start with <TT><B>http://</B></TT>.
<P>
<FONT COLOR=#aa0000><B>Example:</B>  <TT><B>$html_url</B></TT></FONT>
<P>
<UL>
HTML Files URL:
<TABLE><TR><TD><Input TYPE=text SIZE=50 NAME=html_url VALUE="$html_url"></TD></TR></TABLE>
</UL>
</FONT>
</TD></TR>
<TR><TD>&nbsp;</TD></TR>

<TR>
<TD VALIGN=TOP BGCOLOR=#ffcccc WIDTH=200><FONT FACE="Verdana,Arial,Helvetica" SIZE=2><CENTER><B>Script Directory</B></CENTER><P><FONT SIZE=1>
The script directory stores the Perl CGI scripts that power the Discus program.  This directory normally needs to go under your cgi-bin.</FONT></FONT></TD>
<TD>&nbsp;&nbsp;</TD>
<TD VALIGN=TOP>
<FONT FACE="Verdana,Arial,Helvetica" SIZE=2>
The script (CGI) files that come with Discus, such as the board administration script and the new message search, go into the Script Files Directory.  (These are the Perl scripts that actually power Discus by writing to the message files.)
<P>
You need to be able to have your CGI scripts be executed by the server when they are in this directory (which may require you to put this script under your server's cgi-bin or cgi-local directory).   The directory must be a <I>directory</I> and not a URL -- it should <B>not</B> start with <TT><B>http://</B></TT>!
<P>
<FONT COLOR=#aa0000><B>Example:</B>  <TT><B>$script_dir</B></TT></FONT>
<P>
<UL>
Script Files Directory:
<TABLE><TR><TD><Input TYPE=text SIZE=50 NAME=script_dir VALUE="$script_dir"></TD></TR></TABLE>
</UL>
<P>
You also need to give the URL that corresponds to the Script Files Directory that you specified above. This <B>must</B> start with <TT><B>http://</B></TT>.  
<P>
<FONT COLOR=#aa0000><B>Example:</B>  <TT><B>$script_url</B></TT></FONT>
<P>
<UL>
Script Files URL:
<TABLE><TR><TD><Input TYPE=text SIZE=50 NAME=script_url VALUE="$script_url"></TD></TR></TABLE>
</UL>
</FONT>
</TD></TR>
<TR><TD>&nbsp;</TD></TR>

<TR>
<TD VALIGN=TOP BGCOLOR=#ccffcc WIDTH=200><FONT FACE="Verdana,Arial,Helvetica" SIZE=2><CENTER><B>Board Title</B></CENTER><P><FONT SIZE=1>
You can specify the title of your board.</FONT></FONT></TD>
<TD>&nbsp;&nbsp;</TD>
<TD VALIGN=TOP>
<FONT FACE="Verdana,Arial,Helvetica" SIZE=2>
This is, quite simply, the title of your discussion board.
<P>
<FONT COLOR=#aa0000><B>Example:</B>  <TT><B>John's Forum</B></TT></FONT>
<P>
<UL>
Board Title:
<TABLE><TR><TD><Input TYPE=text SIZE=50 NAME=title></TD></TR></TABLE>
</UL></FONT>
</TD></TR>
<TR><TD>&nbsp;</TD></TR>

<TR>
<TD VALIGN=TOP BGCOLOR=#ccffcc WIDTH=200><FONT FACE="Verdana,Arial,Helvetica" SIZE=2><CENTER><B>Board Contact</B></CENTER><P><FONT SIZE=1>
This is where you type your name and e-mail address.</FONT></FONT></TD>
<TD>&nbsp;&nbsp;</TD>
<TD VALIGN=TOP>
<FONT FACE="Verdana,Arial,Helvetica" SIZE=2>
This is the name and e-mail address of the person who is to be contacted if there is a problem with the board.  (When users receive error messages, they are told to contact this person.)
<P>
<FONT COLOR=#aa0000><B>Example:</B>  <TT><B>John Smith</B></TT> is the
contact person, and <TT><B>smith\@johnsmith.com</B></TT> is the e-mail.</FONT>
<P>
<UL>
Board Contact Person:
<TABLE><TR><TD><Input TYPE=text SIZE=50 NAME=contact_name></TD></TR></TABLE>
</UL>
<P>
<UL>
Board Contact E-mail Address:
<TABLE><TR><TD><Input TYPE=text SIZE=50 NAME=contact_email></TD></TR></TABLE>
</UL>
</FONT>
</TD></TR>
<TR><TD>&nbsp;</TD></TR>

<TR>
<TD VALIGN=TOP BGCOLOR=#00aa00 WIDTH=200><FONT FACE="Verdana,Arial,Helvetica" SIZE=2><CENTER><B>Submit the form</B></CENTER><P><FONT SIZE=1>
After double checking your parameters, click the button to generate your individualized distribution of Discus!</FONT></FONT></TD>
<TD>&nbsp;&nbsp;</TD>
<TD VALIGN=TOP>
<FONT FACE="Verdana,Arial,Helvetica" SIZE=2>
When you have filled in all of the blanks above, click the button to generate your individual custom Discus distribution.  Please note that <B>processing could take several seconds</B>, so please click the button only one time, and be patient.
<P>
<CENTER>
<INPUT TYPE=SUBMIT VALUE="Submit Form">
</CENTER>
<P>
</FONT></TD></TR></TABLE>
</FORM>
<P>
<FONT SIZE=1 FACE="Arial,Helvetica">Copyright &copy; 1998, Kevin W. Paulisse and William F. Polik, all rights reserved.</FONT>
</BODY></HTML>
_END_
exit(0);

sub check {
    local ($dr) = @_;
    return 0 if $dr eq "";
    if (-e "$dr/$prog") {
		$real = $dr;
		return 1;
    }
}
exit(0);

sub determine_cwd {
	$filename = $0;
	if ($filename =~ m|(.*)/(.*)|) {
		$filename = $2;
	}
	undef @parent;
	$ctr = 100;
	$dots = "";
O:	while ($ctr > 0) {
		$ctr -= 1;
		$dots .= "/" if $dots ne "";
		$dots .= "..";
		if (opendir(DIR, $dots)) {
I:			while ($dir = readdir(DIR)) {
				next if $dir =~ m|^\.+$|;
				next if !-d "$dots/$dir";
				if (scalar(@parent)) {
					$parent = "/" . join("/", reverse(@parent));
				} else {
					$parent = "";
				}
				if (-e "$dots/$dir$parent/$filename") {
					push (@parent, $dir);
					last I;
				}
			}
			closedir(DIR);
		} else {
			last O;
		}
		$parent = "/" . join("/", reverse(@parent));
		if (-e "$parent/$filename") {
			last O;
		}
	}
	$parent = "/" . join("/", reverse(@parent));
	if ($^O eq "MSWin32") {
		foreach $dr ('c' .. 'z') {
			if (-e "$dr:$parent/$filename") {
				return "$dr:$parent";
			}
		}
	}
	return $parent;
}
